import traceback

from cpl_core.configuration.configuration_model_abc import ConfigurationModelABC
from cpl_core.console import Console


class BootLogServerSettings(ConfigurationModelABC):

    def __init__(self):
        ConfigurationModelABC.__init__(self)

        self._id: int = 0
        self._login_message_channel_id: int = 0

    @property
    def id(self) -> int:
        return self._id
    
    @property
    def login_message_channel_id(self) -> int:
        return self._login_message_channel_id

    def from_dict(self, settings: dict):
        try:
            self._id = int(settings['Id'])
            self._login_message_channel_id = int(settings['LoginMessageChannelId'])
        except Exception as e:
            Console.error(f'[ ERROR ] [ {__name__} ]: Reading error in {type(self).__name__} settings')
            Console.error(f'[ EXCEPTION ] [ {__name__} ]: {e} -> {traceback.format_exc()}')
